package useOfCustomFormatter
{
	import mx.formatters.Formatter;
	import mx.formatters.SwitchSymbolFormatter;

	public class ISBNFormatter extends Formatter
	{
		
		public var formatString : String;// = "####-##-####";
		
		public function ISBNFormatter()
		{
			super();
		}
		
		override public function format(value:Object):String
		{
			// Vérifie la longueur de la string ISBN (10 ou 13 caractères)
			if (!(value.toString().length == 10 ||
				  value.toString().length == 13))
			{
				error = "Invalid String Length";
				return "";
			}
			
			// Vérifie le nombre de # dans la formatString (10 ou 13)
			var numCharCnt:int = 0;
			for (var i:int = 0; i<formatString.length; i++)
			{
				if ( formatString.charAt(i) == "#")
					numCharCnt++;
			}
			if (!(numCharCnt == 10 || numCharCnt == 13))
			{
				error = "Invalid Format String";
				return "";
			}
			
			// Si la valeur et le formatString  sont valides, formatter le contenu
			var dataFormatter:SwitchSymbolFormatter = new SwitchSymbolFormatter();
			return dataFormatter.formatValue(formatString, value);
			
		}
	}
}